// TestDropTargetWithIE.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TestDropTargetWithIE.h"
#include "TestDropTargetWithIEDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestDropTargetWithIEApp

BEGIN_MESSAGE_MAP(CTestDropTargetWithIEApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CTestDropTargetWithIEApp construction

CTestDropTargetWithIEApp::CTestDropTargetWithIEApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CTestDropTargetWithIEApp object

CTestDropTargetWithIEApp theApp;


// CTestDropTargetWithIEApp initialization

BOOL CTestDropTargetWithIEApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	//This is required for Drag & Drop ComboBoxes
	AfxOleInit();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));



	//Allow to receive messages under Vista & later
	VERIFY(AllowMessagesFromLowerLevelProcesses());


	CTestDropTargetWithIEDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}



BOOL CTestDropTargetWithIEApp::AllowMessagesFromLowerLevelProcesses()
{
	//Must be called on Winodws Vista & later OS to allow IE to drag files into this app
	//RETURN:
	//		= TRUE if success
	BOOL bRes = TRUE;

#ifndef MSGFLT_ADD
#define MSGFLT_ADD 1
#endif
#ifndef MSGFLT_REMOVE
#define MSGFLT_REMOVE 2
#endif

#ifndef WM_COPYGLOBALDATA
#define WM_COPYGLOBALDATA 0x0049
#endif

	static UINT nMsgs[] = {
		WM_DROPFILES,
		WM_COPYDATA,
		WM_COPYGLOBALDATA,
		//WM_IME_NOTIFY,
		//WM_IME_SETCONTEXT,
		//0x0118,
	};

	for(int i = 0; i < sizeof(nMsgs) / sizeof(nMsgs[0]); i++)
	{
		if(!ChangeWindowMessageFilter(nMsgs[i], MSGFLT_ADD))
		{
			//Failed
			ASSERT(NULL);
			bRes = FALSE;
		}
	}

	return bRes;
}

